#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
// Quitar para la practica, indicar que con el comando "man" se pueden 
// saber los nombres de las bibliotecas faltantes.
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>

#define BUFSIZE 512

main(int argc, char **argv)
{
	int s, port, r;
	struct sockaddr_in sin;
	struct hostent *hp;
	char buf[BUFSIZE], *pt;
	

	if (argc != 3) 
	  {
	    printf("Uso : %s maquina_remota numero_puerto\n", argv[0]);
	    exit(1);
	}

	port = atoi(argv[2]);
	if (port == 0) {
		printf("Numero de puerto incorrecto. Favor chequear.\n");
		exit(1);
	}
	
	/* 
	   Obtencion de la direccion IP del servidor. En este caso se obtiene
	   a partir de su nombre resuelto a traves del archivo /etc/hosts, del 
	   servidor NIS o del sistema DNS.
	 */
	hp = gethostbyname(argv[1]);
	if (hp == NULL) 
	  {
	    fprintf(stderr, "La funcion gethostbyaddr da error\n");
	    exit(2);
	  }
	/* 
	 Contruccion de la estructura que determina el servidor
	 a consultar.
	 */
	
	// Inicializacion de la estructura sockets in en cero.
	memset((char *)&sin, (unsigned char) 0, sizeof (sin));
	// Rellenando la direccion de entrada con el IP del host destino
	memcpy((char *)&sin.sin_addr, hp->h_addr,  hp->h_length);
        // Rellenando la familia de la direccion	
	sin.sin_family = hp->h_addrtype;
        // Rellenando el numero del puerto
	sin.sin_port = htons(port);

	/* 
	 Apertura del Socket:
	 En esta linea estaremos indicando el tipo del socket
	 para poder abrir una conexion remota del tipo confiable.
	 Vea la secuencia explicada en la lamina #X.
	
	 En los siguientes ejercicios a completar, recuerde evaluar
	 el codigo devuelto por la funcion. Recuerde tambien que la
	 funcion perror() permite escribir los mensajes de error por
	 pantalla. En caso de error, la conducta a seguir es salir
	 del programa.
	*/
	
	// 1) EJERCICIO PARA COMPLETAR  
	// ----------------------------------------------------
	// Pedir un socket (para llevar a cabo una conexion)
	s = socket( ??? , ??? , 0);
	if (s < 0) {
		perror("Error linea 76:");
		exit(1);
	}
	// ----------------------------------------------------

	/*
	 Peticion explicita de la conexion al servidor remoto.
	 */
	
	// 2) EJERCICIO PARA COMPLETAR
	// ----------------------------------------------------
	// Establecer la conexion 
	r = connect( ??? , &sin, sizeof(sin));

	if (r < 0) {
		perror("Error linea 93:");
		exit(1);
	}	
	// ----------------------------------------------------

	/* 
	   Lazo de para efectuar la comunicacion desde el cliente.
	   Debe leerse una cadena de la entrada estandar y luego 
	   ser enviada a traves del socket.
	*/

	printf("Comunicacion desde el cliente\n");
	printf("Escriba un mensaje, dele <ENTER>, salga con <CTRL-D>\n");
	for(;;) {
	  /* Lectura del socket */
	  r = read(s, buf, BUFSIZE);
	  if (r <= 0) {
	    printf("Conexion Interrumpida\n");
	    exit(0);
	  }
	  /* Puesta del final de cadena en el buffer leido */
	  buf[r] = '\0';
	  /* Mostrar por pantalla el mensaje recien leido desde el socket */
	  printf("%s", buf);
	  
	  /* Lectura desde el teclado. Recuerde que haciendo control-D, la
	     funcion gets() devuelve el valor NULL. Cuando se termina la 
	     entrada, se tiene la senal para finalizar el cliente */

	  pt = fgets(buf, BUFSIZE, stdin);
	  if (pt == NULL) 
	    {
	      printf("Cliente finaliza normalmente...\n");
	      exit(0);
	    }
	  // Escritura en el socket hacia el servidor.
	  r = write(s, buf, strlen(buf));
	}
}
