#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
// -- Para quitar durante la practica. Usar el comando man para
// conocer las bibliotecas
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>

#define BUFSIZE 512

main(int argc, char **argv)
{
	int s, ns, r, port, fromlen;
	struct sockaddr_in sin, from;
	struct hostent *hp;
	char buf[BUFSIZE];
	int pid;
	char *message = "Envie un mensaje: ";

	if (argc != 2) {
		printf("Uso: %s puerto_servidor\n", argv[0]);
		exit(1);
	}

	port = atoi(argv[1]);

	if (port < 1024) {
		printf("Por favor ingrese un numero de puerto superior al 1024\n");
		exit(1);
	}

	/*
	   Construccion de la direccion local para realizar el bind.
	*/

	memset((char *)&sin, (unsigned char) 0, sizeof (sin));
	sin.sin_family = AF_INET;
	sin.sin_addr.s_addr = INADDR_ANY;
	sin.sin_port = htons(port);

	// Pedir un socket (para llevar a cabo una conexion)
	// El socket otorgado es tramitado localmente.
	s = socket(AF_INET, SOCK_STREAM, 0);

	if (s == -1 ) {
		perror("solicitud socket");
		exit(2);
	}
	
	// Hace la asociacion de un puerto al socket.
	r = bind (s, &sin, sizeof(sin)); 
	if (r == -1 ) {
		perror("hacer bind");
		exit(3);
	}

	fromlen = sizeof(from);
	// Ciclo de espera y aceptacion de la conexion. 
	for(;;) {
		// Puesta en espera de conexiones. Maximo 5 
		// conexiones el resto son rechazadas. 
		ns = listen(s,5);
		if (ns == -1 ) {
			perror("accept");
			exit(1);
		}

		// Aceptacion de una conexion entrante. 
		ns = accept(s, (struct sockaddr *)&from, &fromlen);
		if (ns == -1 ) {
			perror("accept");
			exit(1);
		}

		/* Identificacion de la maquina cliente. */
		hp = gethostbyaddr((char *)&(from.sin_addr), sizeof(struct in_addr), from.sin_family);
		if (hp == NULL) 
		{
		 fprintf(stderr, "Error gethostbyaddr\n");
		 shutdown(ns, 2);
	         continue;
		}
		else
		{
		 printf("Maquina entrante: %s\n", hp->h_name);
		 // 1) EJERCICIO PARA COMPLETAR: crear un proceso copia
		 // ----------------------------------------------------
		 // Crear el proceso copia:
		 pid = fork();
		 // ----------------------------------------------------
		}

		// 2) EJERCICIO PARA COMPLETAR: diferenciar proceso de espera
		//                              y proc servidor de mensajes.
		// ------------------------------------------------------
		if (pid == 0)
		{	
		// Este gestiona el pase de mensajes entre
		// la maquina cliente y servidor una vez establecida 
		// la conexion...
		for(;;) {
			r = write(ns, message, strlen(message));
			r = read(ns, buf, BUFSIZE);
			if (r <= 0) {
			   printf("finalizacion del cliente\n");
			   break;
			}
			buf[r] = '\0';
			printf("%s\n", buf);
		}
		// 2) EJERCICIO PARA COMPLETAR: salir del programa cuando 
		//				cliente termina.
		// ------------------------------------------------------
		printf("El cliente en puerto %i termino normalmente.",ntohs(from.sin_port));
		exit(0);
		}
	}
}
